Progress bar

- Main Page
- Related Pages
- Data Structures
- Files
- Examples

Functions
Progress bar

## Functions
EOAPI void | elm_obj_progressbar_span_size_set (Evas_Coord size)
| Set the (exact) length of the bar region of a given progress bar widget. More...
EOAPI Evas_Coord | elm_obj_progressbar_span_size_get (void)
| Get the length set for the bar region of a given progress bar widget. More...
EOAPI void | elm_obj_progressbar_pulse_set (Eina_Bool pulse)
| Set whether a given progress bar widget is at "pulsing mode" or not. More...
EOAPI Eina_Bool | elm_obj_progressbar_pulse_get (void)
| Get whether a given progress bar widget is at "pulsing mode" or not. More...
EOAPI void | elm_obj_progressbar_value_set (double val)
| Set the progress value (in percentage) on a given progress bar widget. More...
EOAPI double | elm_obj_progressbar_value_get (void)
| Get the progress value (in percentage) on a given progress bar widget. More...
EOAPI void | elm_obj_progressbar_inverted_set (Eina_Bool inverted)
| Invert a given progress bar widget's displaying values order. More...
EOAPI Eina_Bool | elm_obj_progressbar_inverted_get (void)
| Get whether a given progress bar widget's displaying values are inverted or not. More...
EOAPI void | elm_obj_progressbar_horizontal_set (Eina_Bool horizontal)
| Set the orientation of a given progress bar widget. More...
EOAPI Eina_Bool | elm_obj_progressbar_horizontal_get (void)
| Get the orientation of a given progress bar widget. More...
EOAPI void | elm_obj_progressbar_unit_format_set (const char *units)
| Set the format string for a given progress bar widget's units label. More...
EOAPI const char * | elm_obj_progressbar_unit_format_get (void)
| Get the format string set for a given progress bar widget's units label. More...
EOAPI void | elm_obj_progressbar_unit_format_function_set (progressbar_func_type func, progressbar_freefunc_type free_func)
| Set the format function pointer for the units label. More...
EOAPI void | elm_obj_progressbar_part_value_set (const char *part, double val)
| Set the progress value (in percentage) on a given progress bar widget for the given part name. More...
EOAPI double | elm_obj_progressbar_part_value_get (const char *part)
| Get the progress value (in percentage) on a given progress bar widget for a particular part. More...
EOAPI void | elm_obj_progressbar_pulse (Eina_Bool state)
| Start/stop a given progress bar "pulsing" animation, if its under that mode. More...
void | elm_progressbar_span_size_set (Elm_Progressbar *obj, Evas_Coord size)
| Set the (exact) length of the bar region of a given progress bar widget. More...
Evas_Coord | elm_progressbar_span_size_get (const Elm_Progressbar *obj)
| Get the length set for the bar region of a given progress bar widget. More...
void | elm_progressbar_pulse_set (Elm_Progressbar *obj, Eina_Bool pulse)
| Set whether a given progress bar widget is at "pulsing mode" or not. More...
Eina_Bool | elm_progressbar_pulse_get (const Elm_Progressbar *obj)
| Get whether a given progress bar widget is at "pulsing mode" or not. More...
void | elm_progressbar_value_set (Elm_Progressbar *obj, double val)
| Set the progress value (in percentage) on a given progress bar widget. More...
double | elm_progressbar_value_get (const Elm_Progressbar *obj)
| Get the progress value (in percentage) on a given progress bar widget. More...
void | elm_progressbar_inverted_set (Elm_Progressbar *obj, Eina_Bool inverted)
| Invert a given progress bar widget's displaying values order. More...
Eina_Bool | elm_progressbar_inverted_get (const Elm_Progressbar *obj)
| Get whether a given progress bar widget's displaying values are inverted or not. More...
void | elm_progressbar_horizontal_set (Elm_Progressbar *obj, Eina_Bool horizontal)
| Set the orientation of a given progress bar widget. More...
Eina_Bool | elm_progressbar_horizontal_get (const Elm_Progressbar *obj)
| Get the orientation of a given progress bar widget. More...
void | elm_progressbar_unit_format_set (Elm_Progressbar *obj, const char *units)
| Set the format string for a given progress bar widget's units label. More...
const char * | elm_progressbar_unit_format_get (const Elm_Progressbar *obj)
| Get the format string set for a given progress bar widget's units label. More...
void | elm_progressbar_unit_format_function_set (Elm_Progressbar *obj, progressbar_func_type func, progressbar_freefunc_type free_func)
| Set the format function pointer for the units label. More...
void | elm_progressbar_part_value_set (Elm_Progressbar *obj, const char *part, double val)
| Set the progress value (in percentage) on a given progress bar widget for the given part name. More...
double | elm_progressbar_part_value_get (const Elm_Progressbar *obj, const char *part)
| Get the progress value (in percentage) on a given progress bar widget for a particular part. More...
void | elm_progressbar_pulse (Elm_Progressbar *obj, Eina_Bool state)
| Start/stop a given progress bar "pulsing" animation, if its under that mode. More...
Evas_Object * | elm_progressbar_add (Evas_Object *parent)
| Add a new progress bar widget to the given parent Elementary (container) object. More...

## Detailed Description

The progress bar is a widget for visually representing the progress status of a given job/task.

A progress bar may be horizontal or vertical. It may display an icon besides it, as well as primary and units labels. The former is meant to label the widget as a whole, while the latter, which is formatted with floating point values (and thus accepts a `printf`-style format string, like `"%1.2f units"`), is meant to label the widget's progress value. Label, icon and unit strings/objects are optional for progress bars.

A progress bar may be inverted, in which case it gets its values inverted, i.e., high values being on the left or top and low values on the right or bottom, for horizontal and vertical modes respectively.

The span of the progress, as set by elm_progressbar_span_size_set(), is its length (horizontally or vertically), unless one puts size hints on the widget to expand on desired directions, by any container. That length will be scaled by the object or applications scaling factor. Applications can query the progress bar for its value with elm_progressbar_value_get().

This widget inherits from the Layout one, so that all the functions acting on it also work for progress bar objects.

This widget emits the following signals, besides the ones sent from Layout:

- `"changed"` - when the value is changed (since 1.7)
- `"focused"` - When the progressbar has received focus. (since 1.8)
- `"unfocused"` - When the progressbar has lost focus. (since 1.8)
- `"language,changed"` - the program's language changed (since 1.9)

This widget has the following styles:

- `"default"`
- `"wheel"` (simple style, no text, no progression, only "pulse" effect is available)

Default content parts of the progressbar widget that you can use for are:

- "icon" - An icon of the progressbar

Default text parts of the progressbar widget that you can use for are:

- "default" - A label of the progressbar

Supported elm_object common APIs.

- elm_object_part_text_set
- elm_object_part_text_get
- elm_object_part_content_set
- elm_object_part_content_get
- elm_object_part_content_unset

Here is an example on its usage:

- Progress bar widget example

## Function Documentation

EOAPI Eina_Bool elm_obj_progressbar_horizontal_get | ( | void |  | ) |

Get the orientation of a given progress bar widget.

Returns
  `EINA_TRUE`, if `obj` is set to be horizontal, `EINA_FALSE` if it's vertical (and on errors)

See also
  elm_progressbar_horizontal_set() for more details

Referenced by elm_progressbar_horizontal_get().

EOAPI void elm_obj_progressbar_horizontal_set | ( | Eina_Bool | horizontal | ) |

Set the orientation of a given progress bar widget.

Use this function to change how your progress bar is to be disposed: vertically or horizontally.

See also
  elm_progressbar_horizontal_get()

Parameters

  [in] | horizontal | Use `EINA_TRUE` to make `obj` to be horizontal, `EINA_FALSE` to make it vertical

Referenced by elm_progressbar_horizontal_set().

EOAPI Eina_Bool elm_obj_progressbar_inverted_get | ( | void |  | ) |

Get whether a given progress bar widget's displaying values are inverted or not.

Returns
  `EINA_TRUE`, if `obj` has inverted values, `EINA_FALSE` otherwise (and on errors)

See also
  elm_progressbar_inverted_set() for more details

Referenced by elm_progressbar_inverted_get().

EOAPI void elm_obj_progressbar_inverted_set | ( | Eina_Bool | inverted | ) |

Invert a given progress bar widget's displaying values order.

A progress bar may be inverted, in which state it gets its values inverted, with high values being on the left or top and low values on the right or bottom, as opposed to normally have the low values on the former and high values on the latter, respectively, for horizontal and vertical modes.

See also
  elm_progressbar_inverted_get()

Parameters

  [in] | inverted | Use `EINA_TRUE` to make `obj` inverted, `EINA_FALSE` to bring it back to default, non-inverted values.

Referenced by elm_progressbar_inverted_set().

EOAPI double elm_obj_progressbar_part_value_get | ( | const char * | part | ) |

Get the progress value (in percentage) on a given progress bar widget for a particular part.

Since
  1.8

Returns
  The value of the progressbar

See also
  elm_progressbar_value_set() for more details

Parameters

  [in] | part | The part name of the progress bar

Referenced by elm_progressbar_part_value_get().

EOAPI void elm_obj_progressbar_part_value_set | ( | const char * | part,
|  | double | val
| ) |  |

Set the progress value (in percentage) on a given progress bar widget for the given part name.

Since
  1.8

Use this call to set progress bar status for more than one progress status .

Parameters

  [in] | part | The partname to which val have to set
  [in] | val | The progress value (must be between `0.0` and `1.0`)

Referenced by elm_progressbar_part_value_set().

EOAPI void elm_obj_progressbar_pulse | ( | Eina_Bool | state | ) |

Start/stop a given progress bar "pulsing" animation, if its under that mode.

Note
  This call won't do anything if `obj` is not under "pulsing mode".

See also
  elm_progressbar_pulse_set() for more details.

Parameters

  [in] | state | `EINA_TRUE`, to start the pulsing animation, `EINA_FALSE` to stop it

Referenced by elm_progressbar_pulse().

EOAPI Eina_Bool elm_obj_progressbar_pulse_get | ( | void |  | ) |

Get whether a given progress bar widget is at "pulsing mode" or not.

Returns
  `EINA_TRUE`, if `obj` is in pulsing mode, `EINA_FALSE` if it's in the default one (and on errors)

Referenced by elm_progressbar_pulse_get().

EOAPI void elm_obj_progressbar_pulse_set | ( | Eina_Bool | pulse | ) |

Set whether a given progress bar widget is at "pulsing mode" or not.

By default, progress bars will display values from the low to high value boundaries. There are, though, contexts in which the progress of a given task is unknown. For such cases, one can set a progress bar widget to a "pulsing state", to give the user an idea that some computation is being held, but without exact progress values. In the default theme, it will animate its bar with the contents filling in constantly and back to non-filled, in a loop. To start and stop this pulsing animation, one has to explicitly call elm_progressbar_pulse().

See also
  elm_progressbar_pulse_get()
  elm_progressbar_pulse()

Parameters

  [in] | pulse | `EINA_TRUE` to put `obj` in pulsing mode, `EINA_FALSE` to put it back to its default one

Referenced by elm_progressbar_pulse_set().

EOAPI Evas_Coord elm_obj_progressbar_span_size_get | ( | void |  | ) |

Get the length set for the bar region of a given progress bar widget.

Returns
  The length of the progress bar's bar region

If that size was not set previously, with elm_progressbar_span_size_set(), this call will return `0`.

Referenced by elm_progressbar_span_size_get().

EOAPI void elm_obj_progressbar_span_size_set | ( | Evas_Coord | size | ) |

Set the (exact) length of the bar region of a given progress bar widget.

This sets the minimum width (when in horizontal mode) or height (when in vertical mode) of the actual bar area of the progress bar `obj`. This in turn affects the object's minimum size. Use this when you're not setting other size hints expanding on the given direction (like weight and alignment hints) and you would like it to have a specific size.

Note
  Icon, label and unit text around `obj` will require their own space, which will make `obj` to require more the `size`, actually.

See also
  elm_progressbar_span_size_get()

Parameters

  [in] | size | The length of the progress bar's bar region

Referenced by elm_progressbar_span_size_set().

EOAPI void elm_obj_progressbar_unit_format_function_set | ( | progressbar_func_type | func,
|  | progressbar_freefunc_type | free_func
| ) |  |

Set the format function pointer for the units label.

Set the callback function to format the unit string.

See also
  elm_progressbar_unit_format_set() for more info on how this works.

Since
  1.7

Parameters

  [in] | func | The unit format function
  [in] | free_func | The freeing function for the format string.

Referenced by elm_progressbar_unit_format_function_set().

EOAPI const char* elm_obj_progressbar_unit_format_get | ( | void |  | ) |

Get the format string set for a given progress bar widget's units label.

Returns
  The format set string for `obj's` units label or `NULL`, if none was set (and on errors)

See also
  elm_progressbar_unit_format_set() for more details

Referenced by elm_progressbar_unit_format_get().

EOAPI void elm_obj_progressbar_unit_format_set | ( | const char * | units | ) |

Set the format string for a given progress bar widget's units label.

If `NULL` is passed on `format`, it will make `obj's` units area to be hidden completely. If not, it'll set the format string for the units label's text. The units label is provided a floating point value, so the units text is up display at most one floating point value. Note that the units label is optional. Use a format string such as "%1.2f meters" for example.

Note
  The default format string for a progress bar is an integer percentage, as in `"%.0f %%"`.

See also
  elm_progressbar_unit_format_get()

Parameters

  [in] | units | The format string for `obj's` units label

Referenced by elm_progressbar_unit_format_set().

EOAPI double elm_obj_progressbar_value_get | ( | void |  | ) |

Get the progress value (in percentage) on a given progress bar widget.

Returns
  The value of the progressbar

See also
  elm_progressbar_value_set() for more details

Referenced by elm_progressbar_value_get().

EOAPI void elm_obj_progressbar_value_set | ( | double | val | ) |

Set the progress value (in percentage) on a given progress bar widget.

Use this call to set progress bar levels.

Note
  If you passes a value out of the specified range for `val`, it will be interpreted as the closest of the boundary values in the range.

Parameters

  [in] | val | The progress value (must be between `0.0` and `1.0`)

Referenced by elm_progressbar_value_set().

Evas_Object* elm_progressbar_add | ( | Evas_Object * | parent | ) |

Add a new progress bar widget to the given parent Elementary (container) object.

Parameters

  parent | The parent object

Returns
  a new progress bar widget handle or `NULL`, on errors

This function inserts a new progress bar widget on the canvas.

Eina_Bool elm_progressbar_horizontal_get | ( | const Elm_Progressbar * | obj | ) |

Get the orientation of a given progress bar widget.

Returns
  `EINA_TRUE`, if `obj` is set to be horizontal, `EINA_FALSE` if it's vertical (and on errors)

See also
  elm_progressbar_horizontal_set() for more details

References elm_obj_progressbar_horizontal_get().

void elm_progressbar_horizontal_set | ( | Elm_Progressbar * | obj,
|  | Eina_Bool | horizontal
| ) |  |

Set the orientation of a given progress bar widget.

Use this function to change how your progress bar is to be disposed: vertically or horizontally.

See also
  elm_progressbar_horizontal_get()

Parameters

  [in] | horizontal | Use `EINA_TRUE` to make `obj` to be horizontal, `EINA_FALSE` to make it vertical

References elm_obj_progressbar_horizontal_set().

Eina_Bool elm_progressbar_inverted_get | ( | const Elm_Progressbar * | obj | ) |

Get whether a given progress bar widget's displaying values are inverted or not.

Returns
  `EINA_TRUE`, if `obj` has inverted values, `EINA_FALSE` otherwise (and on errors)

See also
  elm_progressbar_inverted_set() for more details

References elm_obj_progressbar_inverted_get().

void elm_progressbar_inverted_set | ( | Elm_Progressbar * | obj,
|  | Eina_Bool | inverted
| ) |  |

Invert a given progress bar widget's displaying values order.

A progress bar may be inverted, in which state it gets its values inverted, with high values being on the left or top and low values on the right or bottom, as opposed to normally have the low values on the former and high values on the latter, respectively, for horizontal and vertical modes.

See also
  elm_progressbar_inverted_get()

Parameters

  [in] | inverted | Use `EINA_TRUE` to make `obj` inverted, `EINA_FALSE` to bring it back to default, non-inverted values.

References elm_obj_progressbar_inverted_set().

double elm_progressbar_part_value_get | ( | const Elm_Progressbar * | obj,
|  | const char * | part
| ) |  |

Get the progress value (in percentage) on a given progress bar widget for a particular part.

Since
  1.8

Returns
  The value of the progressbar

See also
  elm_progressbar_value_set() for more details

Parameters

  [in] | part | The part name of the progress bar

References elm_obj_progressbar_part_value_get().

void elm_progressbar_part_value_set | ( | Elm_Progressbar * | obj,
|  | const char * | part,
|  | double | val
| ) |  |

Set the progress value (in percentage) on a given progress bar widget for the given part name.

Since
  1.8

Use this call to set progress bar status for more than one progress status .

Parameters

  [in] | part | The partname to which val have to set
  [in] | val | The progress value (must be between `0.0` and `1.0`)

References elm_obj_progressbar_part_value_set().

void elm_progressbar_pulse | ( | Elm_Progressbar * | obj,
|  | Eina_Bool | state
| ) |  |

Start/stop a given progress bar "pulsing" animation, if its under that mode.

Note
  This call won't do anything if `obj` is not under "pulsing mode".

See also
  elm_progressbar_pulse_set() for more details.

Parameters

  [in] | state | `EINA_TRUE`, to start the pulsing animation, `EINA_FALSE` to stop it

References elm_obj_progressbar_pulse().

Eina_Bool elm_progressbar_pulse_get | ( | const Elm_Progressbar * | obj | ) |

Get whether a given progress bar widget is at "pulsing mode" or not.

Returns
  `EINA_TRUE`, if `obj` is in pulsing mode, `EINA_FALSE` if it's in the default one (and on errors)

References elm_obj_progressbar_pulse_get().

void elm_progressbar_pulse_set | ( | Elm_Progressbar * | obj,
|  | Eina_Bool | pulse
| ) |  |

Set whether a given progress bar widget is at "pulsing mode" or not.

By default, progress bars will display values from the low to high value boundaries. There are, though, contexts in which the progress of a given task is unknown. For such cases, one can set a progress bar widget to a "pulsing state", to give the user an idea that some computation is being held, but without exact progress values. In the default theme, it will animate its bar with the contents filling in constantly and back to non-filled, in a loop. To start and stop this pulsing animation, one has to explicitly call elm_progressbar_pulse().

See also
  elm_progressbar_pulse_get()
  elm_progressbar_pulse()

Parameters

  [in] | pulse | `EINA_TRUE` to put `obj` in pulsing mode, `EINA_FALSE` to put it back to its default one

References elm_obj_progressbar_pulse_set().

Evas_Coord elm_progressbar_span_size_get | ( | const Elm_Progressbar * | obj | ) |

Get the length set for the bar region of a given progress bar widget.

Returns
  The length of the progress bar's bar region

If that size was not set previously, with elm_progressbar_span_size_set(), this call will return `0`.

References elm_obj_progressbar_span_size_get().

void elm_progressbar_span_size_set | ( | Elm_Progressbar * | obj,
|  | Evas_Coord | size
| ) |  |

Set the (exact) length of the bar region of a given progress bar widget.

This sets the minimum width (when in horizontal mode) or height (when in vertical mode) of the actual bar area of the progress bar `obj`. This in turn affects the object's minimum size. Use this when you're not setting other size hints expanding on the given direction (like weight and alignment hints) and you would like it to have a specific size.

Note
  Icon, label and unit text around `obj` will require their own space, which will make `obj` to require more the `size`, actually.

See also
  elm_progressbar_span_size_get()

Parameters

  [in] | size | The length of the progress bar's bar region

References elm_obj_progressbar_span_size_set().

void elm_progressbar_unit_format_function_set | ( | Elm_Progressbar * | obj,
|  | progressbar_func_type | func,
|  | progressbar_freefunc_type | free_func
| ) |  |

Set the format function pointer for the units label.

Set the callback function to format the unit string.

See also
  elm_progressbar_unit_format_set() for more info on how this works.

Since
  1.7

Parameters

  [in] | func | The unit format function
  [in] | free_func | The freeing function for the format string.

References elm_obj_progressbar_unit_format_function_set().

const char* elm_progressbar_unit_format_get | ( | const Elm_Progressbar * | obj | ) |

Get the format string set for a given progress bar widget's units label.

Returns
  The format set string for `obj's` units label or `NULL`, if none was set (and on errors)

See also
  elm_progressbar_unit_format_set() for more details

References elm_obj_progressbar_unit_format_get().

void elm_progressbar_unit_format_set | ( | Elm_Progressbar * | obj,
|  | const char * | units
| ) |  |

Set the format string for a given progress bar widget's units label.

If `NULL` is passed on `format`, it will make `obj's` units area to be hidden completely. If not, it'll set the format string for the units label's text. The units label is provided a floating point value, so the units text is up display at most one floating point value. Note that the units label is optional. Use a format string such as "%1.2f meters" for example.

Note
  The default format string for a progress bar is an integer percentage, as in `"%.0f %%"`.

See also
  elm_progressbar_unit_format_get()

Parameters

  [in] | units | The format string for `obj's` units label

References elm_obj_progressbar_unit_format_set().

double elm_progressbar_value_get | ( | const Elm_Progressbar * | obj | ) |

Get the progress value (in percentage) on a given progress bar widget.

Returns
  The value of the progressbar

See also
  elm_progressbar_value_set() for more details

References elm_obj_progressbar_value_get().

void elm_progressbar_value_set | ( | Elm_Progressbar * | obj,
|  | double | val
| ) |  |

Set the progress value (in percentage) on a given progress bar widget.

Use this call to set progress bar levels.

Note
  If you passes a value out of the specified range for `val`, it will be interpreted as the closest of the boundary values in the range.

Parameters

  [in] | val | The progress value (must be between `0.0` and `1.0`)

References elm_obj_progressbar_value_set().